(*
 *  beware IRC services, authipthrottle.pas
 *  Copyright (C) 2002 Bas Steendijk
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *)

{this unit keeps a list of the IP's used for the auth "hello" function and expires them.
this prevents more than one attempt from a single IP within a given time, even after the account itself is gone}

unit authipthrottle;

interface

uses blinklist;

procedure authipthrottle_add(ip,ts:integer);
function authipthrottle_find(ip:integer):integer;
procedure authipthrottle_del(ip:integer);

procedure timehandler;

implementation

uses authbot,btime;

type
  tipthrottle=class(tlinklist)
    ip:integer;
    ts:integer;
  end;

var
  ipthrottlelist:tipthrottle;

procedure authipthrottle_add(ip,ts:integer);
var
  p,p2:tipthrottle;
begin
  p2 := nil;
  p := ipthrottlelist;
  while p <> nil do begin
    if p.ip = ip then begin
      p2 := p;
      break;
    end;
    p := tipthrottle(p.next);
  end;
  if p2 = nil then begin
    p2 := tipthrottle.create;
    linklistadd(tlinklist(ipthrottlelist),tlinklist(p2));
  end;
  p2.ip := ip;
  p2.ts := ts;
end;

function authipthrottle_find(ip:integer):integer;
var
  p:tipthrottle;
begin
  result := 0;
  p := ipthrottlelist;
  while p <> nil do begin
    if p.ip = ip then begin
      result := p.ts;
      exit;
    end;
    p := tipthrottle(p.next);
  end;
end;

procedure authipthrottle_del(ip:integer);
var
  p:tipthrottle;
begin
  p := ipthrottlelist;
  while p <> nil do begin
    if p.ip = ip then begin
      linklistdel(tlinklist(ipthrottlelist),p);
      p.destroy;
      exit;
    end;
    p := tipthrottle(p.next);
  end;
end;

procedure timehandler;
var
  p,p2:tipthrottle;
  expirets:integer;
begin
  if unixtime and 31 = 0 then exit;

  if authbot.locopt.registerthrottle <= 0 then exit;

  expirets := unixtime-authbot.locopt.registerthrottle;

  p := ipthrottlelist;
  while p <> nil do begin
    p2 := tipthrottle(p.next);
    if p.ts < expirets then begin
      linklistdel(tlinklist(ipthrottlelist),p);
      p.destroy;
    end;
    p := p2;
  end;
end;

end.
